QScintilla: QsciScintilla Class Reference

# QsciScintilla Class Reference

The QsciScintilla class implements a higher level, more Qt-like, API to the Scintilla editor widget. More...

`#include <qsciscintilla.h>`

Inherits QsciScintillaBase.

List of all members.

## Public Types

- enum { AiMaintain = 0x01, AiOpening = 0x02, AiClosing = 0x04 }
- enum AutoCompletionSource {
  AcsNone, AcsAll, AcsDocument,
  AcsAPIs
  }
- enum BraceMatch { NoBraceMatch, StrictBraceMatch, SloppyBraceMatch }
- enum CallTipsStyle {
  CallTipsNone, CallTipsNoContext, CallTipsNoAutoCompletionContext,
  CallTipsContext
  }
- enum EdgeMode { EdgeNone = EDGE_NONE, EdgeLine = EDGE_LINE, EdgeBackground = EDGE_BACKGROUND }
- enum EolMode { EolWindows = SC_EOL_CRLF, EolUnix = SC_EOL_LF, EolMac = SC_EOL_CR }
- enum FoldStyle {
  NoFoldStyle, PlainFoldStyle, CircledFoldStyle,
  BoxedFoldStyle, CircledTreeFoldStyle, BoxedTreeFoldStyle
  }
- enum MarkerSymbol {
  Circle = SC_MARK_CIRCLE, Rectangle = SC_MARK_ROUNDRECT, RightTriangle = SC_MARK_ARROW,
  SmallRectangle = SC_MARK_SMALLRECT, RightArrow = SC_MARK_SHORTARROW, Invisible = SC_MARK_EMPTY,
  DownTriangle = SC_MARK_ARROWDOWN, Minus = SC_MARK_MINUS, Plus = SC_MARK_PLUS,
  VerticalLine = SC_MARK_VLINE, BottomLeftCorner = SC_MARK_LCORNER, LeftSideSplitter = SC_MARK_TCORNER,
  BoxedPlus = SC_MARK_BOXPLUS, BoxedPlusConnected = SC_MARK_BOXPLUSCONNECTED, BoxedMinus = SC_MARK_BOXMINUS,
  BoxedMinusConnected = SC_MARK_BOXMINUSCONNECTED, RoundedBottomLeftCorner = SC_MARK_LCORNERCURVE, LeftSideRoundedSplitter = SC_MARK_TCORNERCURVE,
  CircledPlus = SC_MARK_CIRCLEPLUS, CircledPlusConnected = SC_MARK_CIRCLEPLUSCONNECTED, CircledMinus = SC_MARK_CIRCLEMINUS,
  CircledMinusConnected = SC_MARK_CIRCLEMINUSCONNECTED, Background = SC_MARK_BACKGROUND, ThreeDots = SC_MARK_DOTDOTDOT,
  ThreeRightArrows = SC_MARK_ARROWS
  }
- enum WhitespaceVisibility { WsInvisible = SCWS_INVISIBLE, WsVisible = SCWS_VISIBLEALWAYS, WsVisibleAfterIndent = SCWS_VISIBLEAFTERINDENT }
- enum WrapMode { WrapNone = SC_WRAP_NONE, WrapWord = SC_WRAP_WORD, WrapCharacter = SC_WRAP_CHAR }
- enum WrapVisualFlag { WrapFlagNone, WrapFlagByText, WrapFlagByBorder }

## Public Slots

- virtual void append (const QString &text)
- virtual void autoCompleteFromAll ()
- virtual void autoCompleteFromAPIs ()
- virtual void autoCompleteFromDocument ()
- virtual void callTip ()
- virtual void clear ()
- virtual void copy ()
- virtual void cut ()
- virtual void ensureCursorVisible ()
- virtual void ensureLineVisible (int line)
- virtual void foldAll (bool children=false)
- virtual void foldLine (int line)
- virtual void indent (int line)
- virtual void insert (const QString &text)
- virtual void insertAt (const QString &text, int line, int index)
- virtual void moveToMatchingBrace ()
- virtual void paste ()
- virtual void redo ()
- virtual void removeSelectedText ()
- virtual void resetSelectionBackgroundColor ()
- virtual void resetSelectionForegroundColor ()
- virtual void selectAll (bool select=true)
- virtual void selectToMatchingBrace ()
- virtual void setAutoCompletionCaseSensitivity (bool cs)
- virtual void setAutoCompletionReplaceWord (bool replace)
- virtual void setAutoCompletionShowSingle (bool single)
- virtual void setAutoCompletionSource (AutoCompletionSource source)
- virtual void setAutoCompletionThreshold (int thresh)
- virtual void setAutoIndent (bool autoindent)
- virtual void setBraceMatching (BraceMatch bm)
- virtual void setBackspaceUnindents (bool unindent)
- virtual void setCaretForegroundColor (const QColor &col)
- virtual void setCaretLineBackgroundColor (const QColor &col)
- virtual void setCaretLineVisible (bool enable)
- virtual void setCaretWidth (int width)
- virtual void setColor (const QColor &c)
- virtual void setCursorPosition (int line, int index)
- virtual void setEolMode (EolMode mode)
- virtual void setEolVisibility (bool visible)
- virtual void setFolding (FoldStyle fold, int margin=2)
- virtual void setIndentation (int line, int indentation)
- virtual void setIndentationGuides (bool enable)
- virtual void setIndentationGuidesBackgroundColor (const QColor &col)
- virtual void setIndentationGuidesForegroundColor (const QColor &col)
- virtual void setIndentationsUseTabs (bool tabs)
- virtual void setIndentationWidth (int width)
- virtual void setLexer (QsciLexer *lexer=0)
- virtual void setMarginsBackgroundColor (const QColor &col)
- virtual void setMarginsFont (const QFont &f)
- virtual void setMarginsForegroundColor (const QColor &col)
- virtual void setMarginLineNumbers (int margin, bool lnrs)
- virtual void setMarginMarkerMask (int margin, int mask)
- virtual void setMarginSensitivity (int margin, bool sens)
- virtual void setMarginWidth (int margin, int width)
- virtual void setMarginWidth (int margin, const QString &s)
- virtual void setModified (bool m)
- virtual void setPaper (const QColor &c)
- virtual void setReadOnly (bool ro)
- virtual void setSelection (int lineFrom, int indexFrom, int lineTo, int indexTo)
- virtual void setSelectionBackgroundColor (const QColor &col)
- virtual void setSelectionForegroundColor (const QColor &col)
- virtual void setTabIndents (bool indent)
- virtual void setTabWidth (int width)
- virtual void setText (const QString &text)
- virtual void setUtf8 (bool cp)
- virtual void setWhitespaceVisibility (WhitespaceVisibility mode)
- virtual void setWrapMode (WrapMode mode)
- virtual void undo ()
- virtual void unindent (int line)
- virtual void zoomIn (int range)
- virtual void zoomIn ()
- virtual void zoomOut (int range)
- virtual void zoomOut ()
- virtual void zoomTo (int size)

## Signals

- void cursorPositionChanged (int line, int pos)
- void copyAvailable (bool yes)
- void linesChanged ()
- void marginClicked (int margin, int line, Qt::ButtonState state)
- void modificationAttempted ()
- void modificationChanged (bool m)
- void selectionChanged ()
- void textChanged ()
- void userListActivated (int id, const QString &string)

## Public Member Functions

- QsciScintilla (QWidget *parent=0, const char *name=0, WFlags f=0)
- virtual ~QsciScintilla ()
- virtual QStringList apiContext (int pos, int &context_start, int &last_word_start)
- bool autoCompletionCaseSensitivity () const
- bool autoCompletionFillupsEnabled () const
- bool autoCompletionReplaceWord () const
- bool autoCompletionShowSingle () const
- AutoCompletionSource autoCompletionSource () const
- int autoCompletionThreshold () const
- bool autoIndent () const
- bool backspaceUnindents () const
- void beginUndoAction ()
- BraceMatch braceMatching () const
- CallTipsStyle callTipsStyle () const
- int callTipsVisible () const
- void cancelList ()
- bool caseSensitive () const
- void clearRegisteredImages ()
- QColor color () const
- void convertEols (EolMode mode)
- QsciDocument document () const
- void endUndoAction ()
- QColor edgeColor () const
- int edgeColumn () const
- EdgeMode edgeMode () const
- void setFont (const QFont &f)
- EolMode eolMode () const
- bool eolVisibility () const
- virtual bool findFirst (const QString &expr, bool re, bool cs, bool wo, bool wrap, bool forward=true, int line=-1, int index=-1, bool show=true)
- virtual bool findNext ()
- int firstVisibleLine () const
- FoldStyle folding () const
- void getCursorPosition (int *line, int *index) const
- void getSelection (int *lineFrom, int *indexFrom, int *lineTo, int *indexTo) const
- bool hasSelectedText () const
- int indentation (int line) const
- bool indentationGuides () const
- bool indentationsUseTabs () const
- int indentationWidth () const
- bool isCallTipActive () const
- bool isListActive () const
- bool isModified () const
- bool isReadOnly () const
- bool isRedoAvailable () const
- bool isUndoAvailable () const
- bool isUtf8 () const
- bool isWordCharacter (char ch) const
- int lineAt (const QPoint &pos) const
- void lineIndexFromPosition (int position, int *line, int *index) const
- int lineLength (int line) const
- int lines () const
- int length () const
- QsciLexer * lexer () const
- bool marginLineNumbers (int margin) const
- int marginMarkerMask (int margin) const
- bool marginSensitivity (int margin) const
- int marginWidth (int margin) const
- int markerDefine (MarkerSymbol sym, int mnr=-1)
- int markerDefine (char ch, int mnr=-1)
- int markerDefine (const QPixmap &pm, int mnr=-1)
- int markerAdd (int linenr, int mnr)
- unsigned markersAtLine (int linenr) const
- void markerDelete (int linenr, int mnr=-1)
- void markerDeleteAll (int mnr=-1)
- void markerDeleteHandle (int mhandle)
- int markerLine (int mhandle) const
- int markerFindNext (int linenr, unsigned mask) const
- int markerFindPrevious (int linenr, unsigned mask) const
- QColor paper () const
- int positionFromLineIndex (int line, int index) const
- bool read (QIODevice *io)
- virtual void recolor (int start=0, int end=-1)
- void registerImage (int id, const QPixmap &pm)
- virtual void replace (const QString &replaceStr)
- void resetFoldMarginColors ()
- void setFoldMarginColors (const QColor &fore, const QColor &back)
- void setAutoCompletionFillupsEnabled (bool enabled)
- void setAutoCompletionFillups (const char *fillups)
- void setAutoCompletionWordSeparators (const QStringList &separators)
- void setCallTipsBackgroundColor (const QColor &col)
- void setCallTipsForegroundColor (const QColor &col)
- void setCallTipsHighlightColor (const QColor &col)
- void setCallTipsStyle (CallTipsStyle style)
- void setCallTipsVisible (int nr)
- void setDocument (const QsciDocument &document)
- void setEdgeColor (const QColor &col)
- void setEdgeColumn (int colnr)
- void setEdgeMode (EdgeMode mode)
- void setMarkerBackgroundColor (const QColor &col, int mnr=-1)
- void setMarkerForegroundColor (const QColor &col, int mnr=-1)
- void setMatchedBraceBackgroundColor (const QColor &col)
- void setMatchedBraceForegroundColor (const QColor &col)
- void setUnmatchedBraceBackgroundColor (const QColor &col)
- void setUnmatchedBraceForegroundColor (const QColor &col)
- void setWrapVisualFlags (WrapVisualFlag eflag, WrapVisualFlag sflag=WrapFlagNone, int sindent=0)
- QString selectedText () const
- bool selectionToEol () const
- void setSelectionToEol (bool filled)
- void showUserList (int id, const QStringList &list)
- QsciCommandSet * standardCommands () const
- bool tabIndents () const
- int tabWidth () const
- QString text () const
- QString text (int line) const
- int textHeight (int linenr) const
- WhitespaceVisibility whitespaceVisibility () const
- QString wordAtPoint (const QPoint &point) const
- const char * wordCharacters () const
- WrapMode wrapMode () const
- bool write (QIODevice *io) const

## Classes

- struct FindState

## Detailed Description

The QsciScintilla class implements a higher level, more Qt-like, API to the Scintilla editor widget.

QsciScintilla implements methods, signals and slots similar to those found in other Qt editor classes. It also provides a higher level interface to features specific to Scintilla such as syntax styling, call tips, auto-indenting and auto-completion than that provided by QsciScintillaBase.

## Member Enumeration Documentation

anonymous enum

This enum defines the different auto-indentation styles.

Enumerator:

  AiMaintain | A line is automatically indented to match the previous line.
  AiOpening | If the language supported by the current lexer has a specific start of block character (e.g. { in C++), then a line that begins with that character is indented as well as the lines that make up the block. It may be logically ored with AiClosing.
  AiClosing | If the language supported by the current lexer has a specific end of block character (e.g. } in C++), then a line that begins with that character is indented as well as the lines that make up the block. It may be logically ored with AiOpening.

enum QsciScintilla::AutoCompletionSource

This enum defines the different sources for auto-completion lists.

Enumerator:

  AcsNone | No sources are used, ie. automatic auto-completion is disabled.
  AcsAll | The source is all available sources.
  AcsDocument | The source is the current document.
  AcsAPIs | The source is any installed APIs.

enum QsciScintilla::BraceMatch

This enum defines the different brace matching modes. The character pairs {}, [] and () are treated as braces. The Python lexer will also match a : with the end of the corresponding indented block.

Enumerator:

  NoBraceMatch | Brace matching is disabled.
  StrictBraceMatch | Brace matching is enabled for a brace immediately before the current position.
  SloppyBraceMatch | Brace matching is enabled for a brace immediately before or after the current position.

enum QsciScintilla::CallTipsStyle

This enum defines the different call tip styles.

Enumerator:

  CallTipsNone | Call tips are disabled.
  CallTipsNoContext | Call tips are displayed without a context. A context is any scope (e.g. a C++ namespace or a Python module) prior to the function name.
  CallTipsNoAutoCompletionContext | Call tips are displayed with a context only if the user hasn't already implicitly identified the context using autocompletion. Note that this style may not always be able to align the call tip with the text being entered.
  CallTipsContext | Call tips are displayed with a context. Note that this style may not always be able to align the call tip with the text being entered.

enum QsciScintilla::EdgeMode

This enum defines the different edge modes for long lines.

Enumerator:

  EdgeNone | Long lines are not marked.
  EdgeLine | A vertical line is drawn at the column set by setEdgeColumn(). This is recommended for monospace fonts.
  EdgeBackground | The background color of characters after the column limit is changed to the color set by setEdgeColor(). This is recommended for proportional fonts.

enum QsciScintilla::EolMode

This enum defines the different end-of-line modes.

Enumerator:

  EolWindows | A carriage return/line feed as used on Windows systems.
  EolUnix | A line feed as used on Unix systems.
  EolMac | A carriage return as used on Mac systems.

enum QsciScintilla::FoldStyle

This enum defines the different styles for the folding margin.

Enumerator:

  NoFoldStyle | Folding is disabled.
  PlainFoldStyle | Plain folding style using plus and minus symbols.
  CircledFoldStyle | Circled folding style using circled plus and minus symbols.
  BoxedFoldStyle | Boxed folding style using boxed plus and minus symbols.
  CircledTreeFoldStyle | Circled tree style using a flattened tree with circled plus and minus symbols and rounded corners.
  BoxedTreeFoldStyle | Boxed tree style using a flattened tree with boxed plus and minus symbols and right-angled corners.

enum QsciScintilla::MarkerSymbol

This enum defines the different pre-defined marker symbols.

Enumerator:

  Circle | A circle.
  Rectangle | A rectangle.
  RightTriangle | A triangle pointing to the right.
  SmallRectangle | A smaller rectangle.
  RightArrow | An arrow pointing to the right.
  Invisible | An invisible marker that allows code to track the movement of lines.
  DownTriangle | A triangle pointing down.
  Minus | A drawn minus sign.
  Plus | A drawn plus sign.
  VerticalLine | A vertical line drawn in the background colour.
  BottomLeftCorner | A bottom left corner drawn in the background colour.
  LeftSideSplitter | A vertical line with a centre right horizontal line drawn in the background colour.
  BoxedPlus | A drawn plus sign in a box.
  BoxedPlusConnected | A drawn plus sign in a connected box.
  BoxedMinus | A drawn minus sign in a box.
  BoxedMinusConnected | A drawn minus sign in a connected box.
  RoundedBottomLeftCorner | A rounded bottom left corner drawn in the background colour.
  LeftSideRoundedSplitter | A vertical line with a centre right curved line drawn in the background colour.
  CircledPlus | A drawn plus sign in a circle.
  CircledPlusConnected | A drawn plus sign in a connected box.
  CircledMinus | A drawn minus sign in a circle.
  CircledMinusConnected | A drawn minus sign in a connected circle.
  Background | No symbol is drawn but the line of text is drawn with the same background colour.
  ThreeDots | Three drawn dots.
  ThreeRightArrows | Three drawn arrows pointing right.

enum QsciScintilla::WhitespaceVisibility

This enum defines the different whitespace visibility modes. When whitespace is visible spaces are displayed as small centred dots and tabs are displayed as light arrows pointing to the right.

Enumerator:

  WsInvisible | Whitespace is invisible.
  WsVisible | Whitespace is always visible.
  WsVisibleAfterIndent | Whitespace is visible after the whitespace used for indentation.

enum QsciScintilla::WrapMode

This enum defines the different line wrap modes.

Enumerator:

  WrapNone | Lines are not wrapped.
  WrapWord | Lines are wrapped at word boundaries.
  WrapCharacter | Lines are wrapped at character boundaries.

enum QsciScintilla::WrapVisualFlag

This enum defines the different line wrap visual flags.

Enumerator:

  WrapFlagNone | No wrap flag is displayed.
  WrapFlagByText | A wrap flag is displayed by the text.
  WrapFlagByBorder | A wrap flag is displayed by the border.

## Constructor & Destructor Documentation

QsciScintilla::QsciScintilla | ( | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | WFlags | f = `0` |
| ) |  |  |

Construct an empty QsciScintilla with parent parent, name name, and widget flags f.

virtual QsciScintilla::~QsciScintilla | ( |  | ) | `[virtual]`

Destroys the QsciScintilla instance.

## Member Function Documentation

virtual QStringList QsciScintilla::apiContext | ( | int | pos,
|  | int & | context_start,
|  | int & | last_word_start |
| ) |  |  | `[virtual]`

Returns the API context, which is a list of words, before the position pos in the document. The context can be used by auto-completion and call tips to help to identify which API call the user is referring to. In the default implementation the current lexer determines what characters make up a word, and what characters determine the boundaries of words (ie. the start characters). If there is no current lexer then the context will consist of a single word. On return context_start will contain the position in the document of the start of the context and last_word_start will contain the position in the document of the start of the last word of the context.

bool QsciScintilla::autoCompletionCaseSensitivity | ( |  | ) | const

Returns true if auto-completion lists are case sensitive.

See also:
  setAutoCompletionCaseSensitivity()

bool QsciScintilla::autoCompletionFillupsEnabled | ( |  | ) | const

Returns true if auto-completion fill-up characters are enabled.

See also:
  setAutoCompletionFillups(), setAutoCompletionFillupsEnabled()

bool QsciScintilla::autoCompletionReplaceWord | ( |  | ) | const

Returns true if the rest of the word to the right of the current cursor is removed when an item from an auto-completion list is selected.

See also:
  setAutoCompletionReplaceWord()

bool QsciScintilla::autoCompletionShowSingle | ( |  | ) | const

Returns true if the only item in an auto-completion list with a single entry is automatically used and the list not displayed.

See also:
  setAutoCompletionShowSingle()

AutoCompletionSource QsciScintilla::autoCompletionSource | ( |  | ) | const`[inline]`

Returns the current source for the auto-completion list when it is being displayed automatically as the user types.

See also:
  setAutoCompletionSource()

int QsciScintilla::autoCompletionThreshold | ( |  | ) | const`[inline]`

Returns the current threshold for the automatic display of the auto-completion list as the user types.

See also:
  setAutoCompletionThreshold()

bool QsciScintilla::autoIndent | ( |  | ) | const`[inline]`

Returns true if auto-indentation is enabled.

See also:
  setAutoIndent()

bool QsciScintilla::backspaceUnindents | ( |  | ) | const

Returns true if the backspace key unindents a line instead of deleting a character. The default is false.

See also:
  setBackspaceUnindents(), tabIndents(), setTabIndents()

void QsciScintilla::beginUndoAction | ( |  | ) |

Mark the beginning of a sequence of actions that can be undone by a single call to undo().

See also:
  endUndoAction(), undo()

BraceMatch QsciScintilla::braceMatching | ( |  | ) | const`[inline]`

Returns the brace matching mode.

See also:
  setBraceMatching()

CallTipsStyle QsciScintilla::callTipsStyle | ( |  | ) | const`[inline]`

Returns the current call tip style.

See also:
  setCallTipsStyle()

int QsciScintilla::callTipsVisible | ( |  | ) | const`[inline]`

Returns the maximum number of call tips that are displayed.

See also:
  setCallTipsVisible()

void QsciScintilla::cancelList | ( |  | ) |

Cancel any current auto-completion or user defined list.

bool QsciScintilla::caseSensitive | ( |  | ) | const

Returns true if the current language lexer is case sensitive. If there is no current lexer then true is returned.

void QsciScintilla::clearRegisteredImages | ( |  | ) |

Clear all registered images.

See also:
  registerImage()

QColor QsciScintilla::color | ( |  | ) | const

Returns the widget's text (ie. foreground) colour.

See also:
  setColor()

void QsciScintilla::convertEols | ( | EolMode | mode | ) |

All the lines of the text have their end-of-lines converted to mode mode.

See also:
  eolMode(), setEolMode()

QsciDocument QsciScintilla::document | ( |  | ) | const`[inline]`

Returns the attached document.

See also:
  setDocument()

void QsciScintilla::endUndoAction | ( |  | ) |

Mark the end of a sequence of actions that can be undone by a single call to undo().

See also:
  beginUndoAction(), undo()

QColor QsciScintilla::edgeColor | ( |  | ) | const

Returns the color of the marker used to show that a line has exceeded the length set by setEdgeColumn().

See also:
  setEdgeColor(),

  setEdgeColumn

int QsciScintilla::edgeColumn | ( |  | ) | const

Returns the number of the column after which lines are considered to be long.

See also:
  setEdgeColumn()

EdgeMode QsciScintilla::edgeMode | ( |  | ) | const

Returns the edge mode which determines how long lines are marked.

See also:
  setEdgeMode()

void QsciScintilla::setFont | ( | const QFont & | f | ) |

Set the default font. This has no effect if a language lexer has been set.

EolMode QsciScintilla::eolMode | ( |  | ) | const

Returns the end-of-line mode.

See also:
  setEolMode()

bool QsciScintilla::eolVisibility | ( |  | ) | const

Returns the visibility of end-of-lines.

See also:
  setEolVisibility()

virtual bool QsciScintilla::findFirst | ( | const QString & | expr,
|  | bool | re,
|  | bool | cs,
|  | bool | wo,
|  | bool | wrap,
|  | bool | forward = `true`,
|  | int | line = `-1`,
|  | int | index = `-1`,
|  | bool | show = `true` |
| ) |  |  | `[virtual]`

Find the next occurrence of the string expr and return true if expr was found, otherwise returns false. If expr is found it becomes the current selection.

If re is true then expr is interpreted as a regular expression rather than a simple string.

If cs is true then the search is case sensitive.

If wo is true then the search looks for whole word matches only, otherwise it searches for any matching text.

If wrap is true then the search wraps around the end of the text.

If forward is true (the default) then the search is forward from the starting position to the end of the text, otherwise it is backwards to the beginning of the text.

If either line or index are negative (the default) then the search begins from the current cursor position. Otherwise the search begins at position index of line line.

If show is true (the default) then any text found is made visible (ie. it is unfolded).

See also:
  findNext(), replace()

virtual bool QsciScintilla::findNext | ( |  | ) | `[virtual]`

Find the next occurence of the string found using findFirst().

See also:
  findFirst(), replace()

int QsciScintilla::firstVisibleLine | ( |  | ) | const

Returns the number of the first visible line.

FoldStyle QsciScintilla::folding | ( |  | ) | const`[inline]`

Returns the current folding style.

See also:
  setFolding()

void QsciScintilla::getCursorPosition | ( | int * | line,
|  | int * | index |
| ) |  |  | const

Sets *line and *index to the line and index of the cursor.

See also:
  setCursorPosition()

void QsciScintilla::getSelection | ( | int * | lineFrom,
|  | int * | indexFrom,
|  | int * | lineTo,
|  | int * | indexTo |
| ) |  |  | const

If there is a selection, *lineFrom is set to the line number in which the selection begins and *lineTo is set to the line number in which the selection ends. (They could be the same.) *indexFrom is set to the index at which the selection begins within *lineFrom, and *indexTo is set to the index at which the selection ends within *lineTo. If there is no selection, *lineFrom, *indexFrom, *lineTo and *indexTo are all set to -1.

See also:
  setSelection()

bool QsciScintilla::hasSelectedText | ( |  | ) | const`[inline]`

Returns true if some text is selected.

See also:
  selectedText()

int QsciScintilla::indentation | ( | int | line | ) | const

Returns the number of characters that line line is indented by.

See also:
  setIndentation()

bool QsciScintilla::indentationGuides | ( |  | ) | const

Returns true if the display of indentation guides is enabled.

See also:
  setIndentationGuides()

bool QsciScintilla::indentationsUseTabs | ( |  | ) | const

Returns true if indentations are created using tabs and spaces, rather than just spaces. The default is true.

See also:
  setIndentationsUseTabs()

int QsciScintilla::indentationWidth | ( |  | ) | const

Returns the indentation width in characters. The default is 0 which means that the value returned by tabWidth() is actually used.

See also:
  setIndentationWidth(), tabWidth()

bool QsciScintilla::isCallTipActive | ( |  | ) | const

Returns true if a call tip is currently active.

bool QsciScintilla::isListActive | ( |  | ) | const

Returns true if an auto-completion or user defined list is currently active.

bool QsciScintilla::isModified | ( |  | ) | const

Returns true if the text has been modified.

See also:
  setModified(), modificationChanged()

bool QsciScintilla::isReadOnly | ( |  | ) | const

Returns true if the text edit is read-only.

See also:
  setReadOnly()

bool QsciScintilla::isRedoAvailable | ( |  | ) | const

Returns true if there is something that can be redone.

See also:
  redo()

bool QsciScintilla::isUndoAvailable | ( |  | ) | const

Returns true if there is something that can be undone.

See also:
  undo()

bool QsciScintilla::isUtf8 | ( |  | ) | const

Returns true if text is interpreted as being UTF8 encoded. The default is to interpret the text as Latin1 encoded.

See also:
  setUtf8()

bool QsciScintilla::isWordCharacter | ( | char | ch | ) | const

Returns true if character ch is a valid word character.

See also:
  wordCharacters()

int QsciScintilla::lineAt | ( | const QPoint & | pos | ) | const

Returns the line which is at position pos or -1 if there is no line at that position.

void QsciScintilla::lineIndexFromPosition | ( | int | position,
|  | int * | line,
|  | int * | index |
| ) |  |  | const

QScintilla uses the combination of a line number and a character index from the start of that line to specify the position of a character within the text. The underlying Scintilla instead uses a byte index from the start of the text. This will convert the position byte index to the *line line number and *index character index.

See also:
  positionFromLineIndex()

int QsciScintilla::lineLength | ( | int | line | ) | const

Returns the length of line line int bytes or -1 if there is no such line. In order to get the length in characters use text(line).length().

int QsciScintilla::lines | ( |  | ) | const

Returns the number of lines of text.

int QsciScintilla::length | ( |  | ) | const

Returns the length of the text edit's text in bytes. In order to get the length in characters use text().length().

QsciLexer* QsciScintilla::lexer | ( |  | ) | const

Returns the current language lexer used to style text. If it is 0 then syntax styling is disabled.

See also:
  setLexer()

bool QsciScintilla::marginLineNumbers | ( | int | margin | ) | const

Returns true if line numbers are enabled for margin margin.

See also:
  setMarginLineNumbers(), SCI_GETMARGINTYPEN

int QsciScintilla::marginMarkerMask | ( | int | margin | ) | const

Returns the marker mask of margin margin.

See also:
  setMarginMask(), QsciMarker, SCI_GETMARGINMASKN

bool QsciScintilla::marginSensitivity | ( | int | margin | ) | const

Returns true if margin margin is sensitive to mouse clicks.

See also:
  setMarginSensitivity(), marginClicked(), SCI_GETMARGINTYPEN

int QsciScintilla::marginWidth | ( | int | margin | ) | const

Returns the width in pixels of margin margin.

See also:
  setMarginWidth(), SCI_GETMARGINWIDTHN

int QsciScintilla::markerDefine | ( | MarkerSymbol | sym,
|  | int | mnr = `-1` |
| ) |  |  |

Define a marker using the symbol sym with the marker number mnr. If mnr is -1 then the marker number is automatically allocated. The marker number is returned or -1 if the marker number was already allocated or too many markers have been defined.

Markers are small geometric symbols and character used, for example, to indicate the current line or, in debuggers, to indicate breakpoints. If a margin has a width of 0 then its markers are not drawn, but their background colours affect the background colour of the corresponding line of text.

There may be up to 32 markers defined and each line of text has a set of these markers associated with it. Markers are drawn according to their numerical identifier. Markers try to move with their text by tracking where the start of their line moves to. For example, when a line is deleted its markers are added to previous line's markers.

Each marker is identified by a marker number. Each instance of a marker is identified by a marker handle.

int QsciScintilla::markerDefine | ( | char | ch,
|  | int | mnr = `-1` |
| ) |  |  |

Define a marker using the character ch with the marker number mnr. If mnr is -1 then the marker number is automatically allocated. The marker number is returned or -1 if the marker number was already allocated or too many markers have been defined.

int QsciScintilla::markerDefine | ( | const QPixmap & | pm,
|  | int | mnr = `-1` |
| ) |  |  |

Define a marker using a copy of the pixmap pm with the marker number mnr. If mnr is -1 then the marker number is automatically allocated. The marker number is returned or -1 if the marker number was already allocated or too many markers have been defined.

int QsciScintilla::markerAdd | ( | int | linenr,
|  | int | mnr |
| ) |  |  |

Add a marker number mnr to line number linenr. A handle for the marker is returned which can be used to track the marker's position, or -1 if the mnr was invalid.

See also:
  markerDelete(), markerDeleteAll(), markerDeleteHandle()

unsigned QsciScintilla::markersAtLine | ( | int | linenr | ) | const

Returns the 32 bit mask of marker numbers at line number linenr.

See also:
  markerAdd()

void QsciScintilla::markerDelete | ( | int | linenr,
|  | int | mnr = `-1` |
| ) |  |  |

Delete all markers with the marker number mnr in the line linenr. If mnr is -1 then delete all markers from line linenr.

See also:
  markerAdd(), markerDeleteAll(), markerDeleteHandle()

void QsciScintilla::markerDeleteAll | ( | int | mnr = `-1` | ) |

Delete the all markers with the marker number mnr. If mnr is -1 then delete all markers.

See also:
  markerAdd(), markerDelete(), markerDeleteHandle()

void QsciScintilla::markerDeleteHandle | ( | int | mhandle | ) |

Delete the the marker instance with the marker handle mhandle.

See also:
  markerAdd(), markerDelete(), markerDeleteAll()

int QsciScintilla::markerLine | ( | int | mhandle | ) | const

Return the line number that contains the marker instance with the marker handle mhandle.

int QsciScintilla::markerFindNext | ( | int | linenr,
|  | unsigned | mask |
| ) |  |  | const

Return the number of the next line to contain at least one marker from a 32 bit mask of markers. linenr is the line number to start the search from. mask is the mask of markers to search for.

See also:
  markerFindPrevious()

int QsciScintilla::markerFindPrevious | ( | int | linenr,
|  | unsigned | mask |
| ) |  |  | const

Return the number of the previous line to contain at least one marker from a 32 bit mask of markers. linenr is the line number to start the search from. mask is the mask of markers to search for.

See also:
  markerFindNext()

QColor QsciScintilla::paper | ( |  | ) | const

Returns the widget's paper (ie. background) colour.

See also:
  setPaper()

int QsciScintilla::positionFromLineIndex | ( | int | line,
|  | int | index |
| ) |  |  | const

QScintilla uses the combination of a line number and a character index from the start of that line to specify the position of a character within the text. The underlying Scintilla instead uses a byte index from the start of the text. This will return the byte index corresponding to the line line number and index character index.

See also:
  lineIndexFromPosition()

bool QsciScintilla::read | ( | QIODevice * | io | ) |

Reads the current document from the io device and returns true if there was no error.

See also:
  write()

virtual void QsciScintilla::recolor | ( | int | start = `0`,
|  | int | end = `-1` |
| ) |  |  | `[virtual]`

Recolours the document between the start and end positions. start defaults to the start of the document and end defaults to the end of the document.

void QsciScintilla::registerImage | ( | int | id,
|  | const QPixmap & | pm |
| ) |  |  |

Register an image pm with ID id. Registered images can be displayed in auto-completion lists.

See also:
  clearRegisteredImages(), QsciLexer::apiLoad()

virtual void QsciScintilla::replace | ( | const QString & | replaceStr | ) | `[virtual]`

Replace the current selection, set by a previous call to findFirst() or findNext(), with replaceStr.

See also:
  findFirst(), findNext()

void QsciScintilla::resetFoldMarginColors | ( |  | ) |

Reset the fold margin colours to their defaults.

See also:
  setFoldMarginColors()

void QsciScintilla::setFoldMarginColors | ( | const QColor & | fore,
|  | const QColor & | back |
| ) |  |  |

The fold margin may be drawn as a one pixel sized checkerboard pattern of two colours, fore and back.

See also:
  resetFoldMarginColors()

void QsciScintilla::setAutoCompletionFillupsEnabled | ( | bool | enabled | ) |

Enable the use of fill-up characters, either those explicitly set or those set by a lexer. By default, fill-up characters are disabled.

See also:
  autoCompletionFillupsEnabled(), setAutoCompletionFillups()

void QsciScintilla::setAutoCompletionFillups | ( | const char * | fillups | ) |

A fill-up character is one that, when entered while an auto-completion list is being displayed, causes the currently selected item from the list to be added to the text followed by the fill-up character. fillups is the set of fill-up characters. If a language lexer has been set then this is ignored and the lexer defines the fill-up characters. The default is that no fill-up characters are set.

See also:
  autoCompletionFillupsEnabled(), setAutoCompletionFillupsEnabled()

void QsciScintilla::setAutoCompletionWordSeparators | ( | const QStringList & | separators | ) |

A word separator is a sequence of characters that, when entered, causes the auto-completion list to be displayed. If a language lexer has been set then this is ignored and the lexer defines the word separators. The default is that no word separators are set.

See also:
  setAutoCompletionThreshold()

void QsciScintilla::setCallTipsBackgroundColor | ( | const QColor & | col | ) |

Set the background colour of call tips to col. The default is white.

void QsciScintilla::setCallTipsForegroundColor | ( | const QColor & | col | ) |

Set the foreground colour of call tips to col. The default is mid-gray.

void QsciScintilla::setCallTipsHighlightColor | ( | const QColor & | col | ) |

Set the highlighted colour of call tip text to col. The default is dark blue.

void QsciScintilla::setCallTipsStyle | ( | CallTipsStyle | style | ) |

Set the current call tip style. The default is CallTipsNoContext.

See also:
  callTipsStyle()

void QsciScintilla::setCallTipsVisible | ( | int | nr | ) |

Set the maximum number of call tips that are displayed to nr. If the maximum number is 0 then all applicable call tips are displayed. If the maximum number is -1 then one call tip will be displayed with up and down arrows that allow the use to scroll through the full list. The default is -1.

See also:
  callTipsVisible()

void QsciScintilla::setDocument | ( | const QsciDocument & | document | ) |

Attach the document document, replacing the currently attached document.

See also:
  document()

void QsciScintilla::setEdgeColor | ( | const QColor & | col | ) |

Set the color of the marker used to show that a line has exceeded the length set by setEdgeColumn().

See also:
  edgeColor(),

  setEdgeColumn

void QsciScintilla::setEdgeColumn | ( | int | colnr | ) |

Set the number of the column after which lines are considered to be long.

See also:
  edgeColumn()

void QsciScintilla::setEdgeMode | ( | EdgeMode | mode | ) |

Set the edge mode which determines how long lines are marked.

See also:
  edgeMode()

void QsciScintilla::setMarkerBackgroundColor | ( | const QColor & | col,
|  | int | mnr = `-1` |
| ) |  |  |

Set the background colour, including the alpha component, of marker mnr to col. If mnr is -1 then the colour of all markers is set. The default is white.

See also:
  setMarkerForegroundColor()

void QsciScintilla::setMarkerForegroundColor | ( | const QColor & | col,
|  | int | mnr = `-1` |
| ) |  |  |

Set the foreground colour of marker mnr to col. If mnr is -1 then the colour of all markers is set. The default is black.

See also:
  setMarkerBackgroundColor()

void QsciScintilla::setMatchedBraceBackgroundColor | ( | const QColor & | col | ) |

Set the background colour used to display matched braces to col. The default is white.

See also:
  setMatchedBraceForegroundColor()

void QsciScintilla::setMatchedBraceForegroundColor | ( | const QColor & | col | ) |

Set the foreground colour used to display matched braces to col. The default is red.

See also:
  setMatchedBraceBackgroundColor()

void QsciScintilla::setUnmatchedBraceBackgroundColor | ( | const QColor & | col | ) |

Set the background colour used to display unmatched braces to col. The default is white.

See also:
  setUnmatchedBraceForegroundColor()

void QsciScintilla::setUnmatchedBraceForegroundColor | ( | const QColor & | col | ) |

Set the foreground colour used to display unmatched braces to col. The default is blue.

See also:
  setUnmatchedBraceBackgroundColor()

void QsciScintilla::setWrapVisualFlags | ( | WrapVisualFlag | eflag,
|  | WrapVisualFlag | sflag = `WrapFlagNone`,
|  | int | sindent = `0` |
| ) |  |  |

Set the visual flags displayed when a line is wrapped. eflag determines if and where the flag at the end of a line is displayed. sflag determines if and where the flag at the start of a line is displayed. sindent is the number of characters a wrapped line is indented by. By default no visual flags are displayed.

QString QsciScintilla::selectedText | ( |  | ) | const

Returns the selected text or an empty string if there is no currently selected text.

See also:
  hasSelectedText()

bool QsciScintilla::selectionToEol | ( |  | ) | const

Returns whether or not the selection is drawn up to the right hand border.

See also:
  setSelectionToEol()

void QsciScintilla::setSelectionToEol | ( | bool | filled | ) |

Sets whether or not the selection is drawn up to the right hand border. filled is set if the selection is drawn to the border.

See also:
  selectionToEol()

void QsciScintilla::showUserList | ( | int | id,
|  | const QStringList & | list |
| ) |  |  |

Displays a user defined list which can be interacted with like an auto-completion list. id is an identifier for the list which is passed as an argument to the userListActivated() signal and must be at least 1. list is the text with which the list is populated.

See also:
  cancelList(), isListActive(), userListActivated()

QsciCommandSet* QsciScintilla::standardCommands | ( |  | ) | const`[inline]`

The standard command set is returned.

bool QsciScintilla::tabIndents | ( |  | ) | const

Returns true if the tab key indents a line instead of inserting a tab character. The default is true.

See also:
  setTabIndents(), backspaceUnindents(), setBackspaceUnindents()

int QsciScintilla::tabWidth | ( |  | ) | const

Returns the tab width in characters. The default is 8.

See also:
  setTabWidth()

QString QsciScintilla::text | ( |  | ) | const

Returns the text of the current document.

See also:
  setText()

QString QsciScintilla::text | ( | int | line | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Returns the text of line line.

See also:
  setText()

int QsciScintilla::textHeight | ( | int | linenr | ) | const

Returns the height in pixels of the text in line number linenr.

WhitespaceVisibility QsciScintilla::whitespaceVisibility | ( |  | ) | const

Returns the visibility of whitespace.

See also:
  setWhitespaceVisibility()

QString QsciScintilla::wordAtPoint | ( | const QPoint & | point | ) | const

Returns the word at the point screen coordinates.

const char* QsciScintilla::wordCharacters | ( |  | ) | const

Returns the set of valid word character as defined by the current language lexer. If there is no current lexer then the set contains an an underscore, numbers and all upper and lower case alphabetic characters.

See also:
  isWordCharacter()

WrapMode QsciScintilla::wrapMode | ( |  | ) | const

Returns the line wrap mode.

See also:
  setWrapMode()

bool QsciScintilla::write | ( | QIODevice * | io | ) | const

Writes the current document to the io device and returns true if there was no error.

See also:
  read()

virtual void QsciScintilla::append | ( | const QString & | text | ) | `[virtual, slot]`

Appends the text text to the end of the text edit. Note that the undo/redo history is cleared by this function.

virtual void QsciScintilla::autoCompleteFromAll | ( |  | ) | `[virtual, slot]`

Display an auto-completion list based on any installed APIs, the current contents of the document and the characters immediately to the left of the cursor.

See also:
  autoCompleteFromAPIs(), autoCompleteFromDocument()

virtual void QsciScintilla::autoCompleteFromAPIs | ( |  | ) | `[virtual, slot]`

Display an auto-completion list based on any installed APIs and the characters immediately to the left of the cursor.

See also:
  autoCompleteFromAll(), autoCompleteFromDocument(), setAutoCompletionAPIs()

virtual void QsciScintilla::autoCompleteFromDocument | ( |  | ) | `[virtual, slot]`

Display an auto-completion list based on the current contents of the document and the characters immediately to the left of the cursor.

See also:
  autoCompleteFromAll(), autoCompleteFromAPIs()

virtual void QsciScintilla::callTip | ( |  | ) | `[virtual, slot]`

Display a call tip based on the the characters immediately to the left of the cursor.

virtual void QsciScintilla::clear | ( |  | ) | `[virtual, slot]`

Deletes all the text in the text edit.

virtual void QsciScintilla::copy | ( |  | ) | `[virtual, slot]`

Copies any selected text to the clipboard.

See also:
  copyAvailable(), cut(), paste()

virtual void QsciScintilla::cut | ( |  | ) | `[virtual, slot]`

Copies any selected text to the clipboard and then deletes the text.

See also:
  copy(), paste()

virtual void QsciScintilla::ensureCursorVisible | ( |  | ) | `[virtual, slot]`

Ensures that the cursor is visible.

virtual void QsciScintilla::ensureLineVisible | ( | int | line | ) | `[virtual, slot]`

Ensures that the line number line is visible.

virtual void QsciScintilla::foldAll | ( | bool | children = `false` | ) | `[virtual, slot]`

If any lines are currently folded then they are all unfolded. Otherwise all lines are folded. This has the same effect as clicking in the fold margin with the shift and control keys pressed. If children is not set (the default) then only the top level fold points are affected, otherwise the state of all fold points are changed.

virtual void QsciScintilla::foldLine | ( | int | line | ) | `[virtual, slot]`

If the line line is folded then it is unfolded. Otherwise it is folded. This has the same effect as clicking in the fold margin.

virtual void QsciScintilla::indent | ( | int | line | ) | `[virtual, slot]`

Increases the indentation of line line by an indentation width.

See also:
  unindent()

virtual void QsciScintilla::insert | ( | const QString & | text | ) | `[virtual, slot]`

Insert the text text at the current position.

virtual void QsciScintilla::insertAt | ( | const QString & | text,
|  | int | line,
|  | int | index |
| ) |  |  | `[virtual, slot]`

Insert the text text in the line line at the position index.

virtual void QsciScintilla::moveToMatchingBrace | ( |  | ) | `[virtual, slot]`

If the cursor is either side of a brace character then move it to the position of the corresponding brace.

virtual void QsciScintilla::paste | ( |  | ) | `[virtual, slot]`

Pastes any text from the clipboard into the text edit at the current cursor position.

See also:
  copy(), cut()

virtual void QsciScintilla::redo | ( |  | ) | `[virtual, slot]`

Redo the last change or sequence of changes.

See also:
  isRedoAvailable()

virtual void QsciScintilla::removeSelectedText | ( |  | ) | `[virtual, slot]`

Removes any selected text.

virtual void QsciScintilla::resetSelectionBackgroundColor | ( |  | ) | `[virtual, slot]`

Resets the background colour of selected text to the default.

See also:
  setSelectionBackgroundColor(), resetSelectionForegroundColor()

virtual void QsciScintilla::resetSelectionForegroundColor | ( |  | ) | `[virtual, slot]`

Resets the foreground colour of selected text to the default.

See also:
  setSelectionForegroundColor(), resetSelectionBackgroundColor()

virtual void QsciScintilla::selectAll | ( | bool | select = `true` | ) | `[virtual, slot]`

If select is true (the default) then all the text is selected. If select is false then any currently selected text is deselected.

virtual void QsciScintilla::selectToMatchingBrace | ( |  | ) | `[virtual, slot]`

If the cursor is either side of a brace character then move it to the position of the corresponding brace and select the text between the braces.

virtual void QsciScintilla::setAutoCompletionCaseSensitivity | ( | bool | cs | ) | `[virtual, slot]`

If cs is true then auto-completion lists are case sensitive. The default is true. This is ignored when the auto-completion source is an installed API as the corresponding language determines the case sensitivity.

See also:
  autoCompletionCaseSensitivity()

virtual void QsciScintilla::setAutoCompletionReplaceWord | ( | bool | replace | ) | `[virtual, slot]`

If replace is true then when an item from an auto-completion list is selected, the rest of the word to the right of the current cursor is removed. The default is false.

See also:
  autoCompletionReplaceWord()

virtual void QsciScintilla::setAutoCompletionShowSingle | ( | bool | single | ) | `[virtual, slot]`

If single is true then when there is only a single entry in an auto-completion list it is automatically used and the list is not displayed. This only has an effect when auto-completion is explicitly requested (using autoCompleteFromAPIs() and autoCompleteFromDocument()) and has no effect when auto-completion is triggered as the user types. The default is false.

See also:
  autoCompletionShowSingle()

virtual void QsciScintilla::setAutoCompletionSource | ( | AutoCompletionSource | source | ) | `[virtual, slot]`

Sets the source for the auto-completion list when it is being displayed automatically as the user types to source. The default is AcsNone, ie. it is disabled.

See also:
  autoCompletionSource()

virtual void QsciScintilla::setAutoCompletionThreshold | ( | int | thresh | ) | `[virtual, slot]`

Sets the threshold for the automatic display of the auto-completion list as the user types to thresh. The threshold is the number of characters that the user must type before the list is displayed. If the threshold is less than or equal to 0 then the list is disabled. The default is -1.

See also:
  autoCompletionThreshold(), setAutoCompletionWordSeparators()

virtual void QsciScintilla::setAutoIndent | ( | bool | autoindent | ) | `[virtual, slot]`

If autoindent is true then auto-indentation is enabled. The default is false.

See also:
  autoIndent()

virtual void QsciScintilla::setBraceMatching | ( | BraceMatch | bm | ) | `[virtual, slot]`

Sets the brace matching mode to bm. The default is NoBraceMatching.

See also:
  braceMatching()

virtual void QsciScintilla::setBackspaceUnindents | ( | bool | unindent | ) | `[virtual, slot]`

If deindent is true then the backspace key will unindent a line rather then delete a character.

See also:
  backspaceUnindents(), tabIndents(), setTabIndents()

virtual void QsciScintilla::setCaretForegroundColor | ( | const QColor & | col | ) | `[virtual, slot]`

Sets the foreground colour of the caret to col.

virtual void QsciScintilla::setCaretLineBackgroundColor | ( | const QColor & | col | ) | `[virtual, slot]`

Sets the background colour, including the alpha component, of the line containing the caret to col.

See also:
  setCaretLineVisible()

virtual void QsciScintilla::setCaretLineVisible | ( | bool | enable | ) | `[virtual, slot]`

Enables or disables, according to enable, the background color of the line containing the caret.

See also:
  setCaretLineBackgroundColor()

virtual void QsciScintilla::setCaretWidth | ( | int | width | ) | `[virtual, slot]`

Sets the width of the caret to width pixels. A width of 0 makes the caret invisible.

virtual void QsciScintilla::setColor | ( | const QColor & | c | ) | `[virtual, slot]`

The widget's text (ie. foreground) colour is set to c. This has no effect if a language lexer has been set.

See also:
  color()

virtual void QsciScintilla::setCursorPosition | ( | int | line,
|  | int | index |
| ) |  |  | `[virtual, slot]`

Sets the cursor to the line line at the position index.

See also:
  getCursorPosition()

virtual void QsciScintilla::setEolMode | ( | EolMode | mode | ) | `[virtual, slot]`

Sets the end-of-line mode to mode. The default is the platform's natural mode.

See also:
  eolMode()

virtual void QsciScintilla::setEolVisibility | ( | bool | visible | ) | `[virtual, slot]`

If visible is true then end-of-lines are made visible. The default is that they are invisible.

See also:
  eolVisibility()

virtual void QsciScintilla::setFolding | ( | FoldStyle | fold,
|  | int | margin = `2` |
| ) |  |  | `[virtual, slot]`

Sets the folding style for margin margin to fold. The default style is NoFoldStyle (ie. folding is disabled) and the default margin is 2.

See also:
  folding()

virtual void QsciScintilla::setIndentation | ( | int | line,
|  | int | indentation |
| ) |  |  | `[virtual, slot]`

Sets the indentation of line line to indentation characters.

See also:
  indentation()

virtual void QsciScintilla::setIndentationGuides | ( | bool | enable | ) | `[virtual, slot]`

Enables or disables, according to enable, this display of indentation guides.

See also:
  indentationGuides()

virtual void QsciScintilla::setIndentationGuidesBackgroundColor | ( | const QColor & | col | ) | `[virtual, slot]`

Set the background colour of indentation guides to col.

See also:
  setIndentationGuidesForegroundColor()

virtual void QsciScintilla::setIndentationGuidesForegroundColor | ( | const QColor & | col | ) | `[virtual, slot]`

Set the foreground colour of indentation guides to col.

See also:
  setIndentationGuidesBackgroundColor()

virtual void QsciScintilla::setIndentationsUseTabs | ( | bool | tabs | ) | `[virtual, slot]`

If tabs is true then indentations are created using tabs and spaces, rather than just spaces.

See also:
  indentationsUseTabs()

virtual void QsciScintilla::setIndentationWidth | ( | int | width | ) | `[virtual, slot]`

Sets the indentation width to width characters. If width is 0 then the value returned by tabWidth() is used.

See also:
  indentationWidth(), tabWidth()

virtual void QsciScintilla::setLexer | ( | QsciLexer * | lexer = `0` | ) | `[virtual, slot]`

Sets the specific language lexer used to style text to lex. If lex is 0 then syntax styling is disabled.

See also:
  lexer()

virtual void QsciScintilla::setMarginsBackgroundColor | ( | const QColor & | col | ) | `[virtual, slot]`

Set the background colour of all margins to col. The default is a gray.

See also:
  setMarginsForegroundColor()

virtual void QsciScintilla::setMarginsFont | ( | const QFont & | f | ) | `[virtual, slot]`

Set the font used in all margins to f.

virtual void QsciScintilla::setMarginsForegroundColor | ( | const QColor & | col | ) | `[virtual, slot]`

Set the foreground colour of all margins to col. The default is black.

See also:
  setMarginsBackgroundColor()

virtual void QsciScintilla::setMarginLineNumbers | ( | int | margin,
|  | bool | lnrs |
| ) |  |  | `[virtual, slot]`

Enables or disables, according to lnrs, the display of line numbers in margin margin.

See also:
  marginLineNumbers(), SCI_SETMARGINTYPEN

virtual void QsciScintilla::setMarginMarkerMask | ( | int | margin,
|  | int | mask |
| ) |  |  | `[virtual, slot]`

Sets the marker mask of margin margin to mask. Only those markers whose bit is set in the mask are displayed in the margin.

See also:
  marginMarkerMask(), QsciMarker, SCI_SETMARGINMASKN

virtual void QsciScintilla::setMarginSensitivity | ( | int | margin,
|  | bool | sens |
| ) |  |  | `[virtual, slot]`

Enables or disables, according to sens, the sensitivity of margin margin to mouse clicks. If the user clicks in a sensitive margin the marginClicked() signal is emitted.

See also:
  marginSensitivity(), marginClicked(), SCI_SETMARGINSENSITIVEN

virtual void QsciScintilla::setMarginWidth | ( | int | margin,
|  | int | width |
| ) |  |  | `[virtual, slot]`

Sets the width of margin margin to width pixels. If the width of a margin is 0 then it is not displayed.

See also:
  marginWidth(), SCI_SETMARGINWIDTHN

virtual void QsciScintilla::setMarginWidth | ( | int | margin,
|  | const QString & | s |
| ) |  |  | `[virtual, slot]`

Sets the width of margin margin so that it is wide enough to display s in the current margin font.

See also:
  marginWidth(), SCI_SETMARGINWIDTHN

virtual void QsciScintilla::setModified | ( | bool | m | ) | `[virtual, slot]`

Sets the modified state of the text edit to m. Note that it is only possible to clear the modified state (where m is false). Attempts to set the modified state (where m is true) are ignored.

See also:
  isModified(), modificationChanged()

virtual void QsciScintilla::setPaper | ( | const QColor & | c | ) | `[virtual, slot]`

The widget's paper (ie. background) colour is set to c. This has no effect if a language lexer has been set.

See also:
  paper()

virtual void QsciScintilla::setReadOnly | ( | bool | ro | ) | `[virtual, slot]`

Sets the read-only state of the text edit to ro.

See also:
  isReadOnly()

virtual void QsciScintilla::setSelection | ( | int | lineFrom,
|  | int | indexFrom,
|  | int | lineTo,
|  | int | indexTo |
| ) |  |  | `[virtual, slot]`

Sets the selection which starts at position indexFrom in line lineFrom and ends at position indexTo in line lineTo. The cursor is moved to position indexTo in lineTo.

See also:
  getSelection()

virtual void QsciScintilla::setSelectionBackgroundColor | ( | const QColor & | col | ) | `[virtual, slot]`

Sets the background colour, including the alpha component, of selected text to col.

See also:
  resetSelectionBackgroundColor(), setSelectionForegroundColor()

virtual void QsciScintilla::setSelectionForegroundColor | ( | const QColor & | col | ) | `[virtual, slot]`

Sets the foreground colour of selected text to col.

See also:
  resetSelectionForegroundColor(), setSelectionBackgroundColor()

virtual void QsciScintilla::setTabIndents | ( | bool | indent | ) | `[virtual, slot]`

If indent is true then the tab key will indent a line rather than insert a tab character.

See also:
  tabIndents(), backspaceUnindents(), setBackspaceUnindents()

virtual void QsciScintilla::setTabWidth | ( | int | width | ) | `[virtual, slot]`

Sets the tab width to width characters.

See also:
  tabWidth()

virtual void QsciScintilla::setText | ( | const QString & | text | ) | `[virtual, slot]`

Replaces all of the current text with text. Note that the undo/redo history is cleared by this function.

See also:
  text()

virtual void QsciScintilla::setUtf8 | ( | bool | cp | ) | `[virtual, slot]`

Sets the current text encoding. If cp is true then UTF8 is used, otherwise Latin1 is used.

See also:
  isUtf8()

virtual void QsciScintilla::setWhitespaceVisibility | ( | WhitespaceVisibility | mode | ) | `[virtual, slot]`

Sets the visibility of whitespace to mode mode. The default is that whitespace is invisible.

See also:
  whitespaceVisibility()

virtual void QsciScintilla::setWrapMode | ( | WrapMode | mode | ) | `[virtual, slot]`

Sets the line wrap mode to mode mode. The default is that lines are not wrapped.

See also:
  wrapMode()

virtual void QsciScintilla::undo | ( |  | ) | `[virtual, slot]`

Undo the last change or sequence of changes.

Scintilla has multiple level undo and redo. It will continue to record undoable actions until memory runs out. Sequences of typing or deleting are compressed into single actions to make it easier to undo and redo at a sensible level of detail. Sequences of actions can be combined into actions that are undone as a unit. These sequences occur between calls to beginUndoAction() and endUndoAction(). These sequences can be nested and only the top level sequences are undone as units.

See also:
  beginUndoAction(), endUndoAction(), isUndoAvailable()

virtual void QsciScintilla::unindent | ( | int | line | ) | `[virtual, slot]`

Decreases the indentation of line line by an indentation width.

See also:
  indent()

virtual void QsciScintilla::zoomIn | ( | int | range | ) | `[virtual, slot]`

Zooms in on the text by by making the base font size range points larger and recalculating all font sizes.

See also:
  zoomOut(), zoomTo()

virtual void QsciScintilla::zoomIn | ( |  | ) | `[virtual, slot]`

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Zooms in on the text by by making the base font size one point larger and recalculating all font sizes.

virtual void QsciScintilla::zoomOut | ( | int | range | ) | `[virtual, slot]`

Zooms out on the text by by making the base font size range points smaller and recalculating all font sizes.

See also:
  zoomIn(), zoomTo()

virtual void QsciScintilla::zoomOut | ( |  | ) | `[virtual, slot]`

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. Zooms out on the text by by making the base font size one point larger and recalculating all font sizes.

virtual void QsciScintilla::zoomTo | ( | int | size | ) | `[virtual, slot]`

Zooms the text by making the base font size size points and recalculating all font sizes.

See also:
  zoomIn(), zoomOut()

void QsciScintilla::cursorPositionChanged | ( | int | line,
|  | int | pos |
| ) |  |  | `[signal]`

This signal is emitted whenever the cursor position changes. line contains the line number and pos contains the character position within the line.

void QsciScintilla::copyAvailable | ( | bool | yes | ) | `[signal]`

This signal is emitted whenever text is selected or de-selected. yes is true if text has been selected and false if text has been deselected. If yes is true then copy() can be used to copy the selection to the clipboard. If yes is false then copy() does nothing.

See also:
  copy(), selectionChanged()

void QsciScintilla::linesChanged | ( |  | ) | `[signal]`

This signal is emitted whenever the number of lines of text changes.

void QsciScintilla::marginClicked | ( | int | margin,
|  | int | line,
|  | Qt::ButtonState | state |
| ) |  |  | `[signal]`

This signal is emitted whenever the user clicks on a sensitive margin. margin is the margin. line is the number of the line where the user clicked. state is the state of the modifier keys (ShiftButton, ControlButton and AltButton) when the user clicked.

See also:
  marginSensitivity(), setMarginSensitivity()

void QsciScintilla::modificationAttempted | ( |  | ) | `[signal]`

This signal is emitted whenever the user attempts to modify read-only text.

See also:
  isReadOnly(), setReadOnly()

void QsciScintilla::modificationChanged | ( | bool | m | ) | `[signal]`

This signal is emitted whenever the modification state of the text changes. m is true if the text has been modified.

See also:
  isModified(), setModified()

void QsciScintilla::selectionChanged | ( |  | ) | `[signal]`

This signal is emitted whenever the selection changes.

See also:
  copyAvailable()

void QsciScintilla::textChanged | ( |  | ) | `[signal]`

This signal is emitted whenever the text in the text edit changes.

void QsciScintilla::userListActivated | ( | int | id,
|  | const QString & | string |
| ) |  |  | `[signal]`

This signal is emitted when an item in a user defined list is activated (selected). id is the list identifier. string is the text of the item.

See also:
  showUserList()